/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) 1996-2002, Emmanuel Curis

   Interface graphique : routines gnrales indpendantes du systme

   Arbre cr au vol : pour demander des valeurs
   Dclarations (indpendantes de LASE)
*/

#ifndef BI_ARBRES_H_
# define BI_ARBRES_H_ /* Protection / inclusion multiple */

/* -------- Fonction pour les messages d'erreur -------- */

#define BI_NOMBRE_MAX_BOUTONS_ALERTE 5

typedef struct {
  int icone;         /* numro de l'icne  utiliser */
  const char *titre; /* le titre du message, dans la barre de titre de la fentre */
  const char *texte; /* le texte du message (%s, %c, %d, %u, %l, %f, %F autoriss) */
  unsigned int nbr_boutons; /* le nombre de boutons.*/
  unsigned int bouton_ok;   /* bouton simul par Entre [0 = aucun] */
  unsigned int bouton_esc;  /* bouton simul par Esc    [0 = aucun] */
  const char *boutons[ BI_NOMBRE_MAX_BOUTONS_ALERTE ];    /* Textes des boutons */
} BI_Boite_Alerte;

int  BI_ERR_alerte (Fenetre *mere, const BI_Boite_Alerte *boite, boolean bloquante,...);
void BI_ERR_annuler(const char *texte,...);

#endif
