/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) 1996-2003, Emmanuel Curis

   Interface graphique : routines gnrales indpendantes du systme

   Chargement de fichiers RSC pour creer des arbres
   Dclarations (indpendantes de LASE)
*/

#ifndef BI_RSC_H_
# define BI_RSC_H_ /* Protection / inclusion multiple */

/* Informations dcrivant un fichier RSC */
struct rsc_infos {
  FILE *fichier;
  long deb_objets;
  long deb_tedinfo;
  long deb_iconblk;
  long deb_bitblk;
  long deb_ch_libres;
  long deb_chaines;
  long deb_images;
  long deb_img_libres;
  unsigned long table_arbres;
  unsigned long nbr_objets;
  unsigned long nbr_arbres;
  unsigned long nbr_tedinfos;
  unsigned long nbr_iconblk;
  unsigned long nbr_bitblk;
  unsigned long nbr_chaines;
  unsigned long nbr_images;
  unsigned long taille_ressource;
};

int BI_ChargerRSC(const char *nom_fichier, unsigned int idx_premier, unsigned int *nbr_arbres);
char *BI_TrouverRSC(const char *nom_fichier);

int BI_RSC_LireArbres       (struct rsc_infos *infos, unsigned int idx_premier);
int BI_RSC_LireEnTeteFichier(const char *nom_fichier, struct rsc_infos *infos);

/* Ici, car dpend a priori du systme,  cause du codage des accents [pfff...] */
char *BI_RSC_LireChaine(struct rsc_infos *infos, unsigned long position);

#endif /* BI_RSC_H_ */
