/* Essai de la bib. X
   (C) 1999, Emmanuel CURIS

   Programme 1 : initialisation, ouverture d'une fentre qui contient un losange.
   Un appui sur une touche quitte le programme
   Il y a un rticule sur la fentre
*/

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"

float Zdist = 0.0;

void redessin(Fenetre *fenetre, int x, int y, unsigned int larg, unsigned int haut)
{
  if (fenetre == NULL) return;

#ifdef AVEC_OPENGL_
  // INIT
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glShadeModel(GL_SMOOTH);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glEnable(GL_DEPTH_TEST);

  // RESHAPE

  // Choose the projection matrix to be the matrix 
  // manipulated by the following calls
  glMatrixMode(GL_PROJECTION);

  // Set the projection matrix to be the identity matrix
  glLoadIdentity();

  // Define the dimensions of the Orthographic Viewing Volume
  //	glOrtho(-8.0, 8.0, -8.0, 8.0, -8.0, 8.0);
  glFrustum(-8.0, 8.0, -8.0, 8.0, 50.0, 200.0);

  // Choose the modelview matrix to be the matrix
  // manipulated by further calls
  glMatrixMode(GL_MODELVIEW);

  // DRAW

  // Clear the RGB buffer and the depth buffer
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Set the modelview matrix to be the identity matrix
  glLoadIdentity();
  glTranslatef(0, 0, Zdist);


  glPushMatrix();
  // Translate and rotate the object
  glTranslatef(-2.5, 0.0, 0.0);
  glRotatef(-30, 1.0, 0.0, 0.0);
  glRotatef(30, 0.0, 1.0, 0.0);
  glRotatef(30, 0.0, 0.0, 1.0);

  glColor3f(1.0, 0.0, 1.0);

  // Draw the sides of the three-sided pyramid
  glBegin(GL_TRIANGLE_FAN);
    glVertex3d(0, 4, 0);
    glVertex3d(0, -4, -4);
    glVertex3d(-4, -4, 4);
    glVertex3d(4, -4, 4);
    glVertex3d(0, -4, -4);
  glEnd();

  glColor3f(0.0, 1.0, 1.0);

  // Draw the base of the pyramid
  glBegin(GL_TRIANGLES);
    glVertex3d(0, -4, -4);
    glVertex3d(-4, -4, 4);
    glVertex3d(4, -4, 4);
  glEnd();

  glPopMatrix();
  glPushMatrix();

  glRotatef(Zdist, 0, 1, 0.1);

  glTranslatef(2.5, 0.0, 0.0);
  glRotatef(45, 1.0, 0.0, 0.0);
  glRotatef(45, 0.0, 1.0, 0.0);
  glRotatef(45, 0.0, 0.0, 1.0);

  glColor3f(0.0, 1.0, 0.0);

  // Draw the sides of the cube
  glBegin(GL_QUAD_STRIP);
    glVertex3d(3, 3, -3);
    glVertex3d(3, -3, -3);
    glVertex3d(-3, 3, -3);
    glVertex3d(-3, -3, -3);
    glVertex3d(-3, 3, 3);
    glVertex3d(-3, -3, 3);
    glVertex3d(3, 3, 3);
    glVertex3d(3, -3, 3);
    glVertex3d(3, 3, -3);
    glVertex3d(3, -3, -3);
  glEnd();

  glColor3f(0.0, 0.0, 1.0);

  // Draw the top and bottom of the cube
  glBegin(GL_QUADS);
    glVertex3d(-3, -3, -3);
    glVertex3d(3, -3, -3);
    glVertex3d(3, -3, 3);
    glVertex3d(-3, -3, 3);

    glVertex3d(-3, 3, -3);
    glVertex3d(3, 3, -3);
    glVertex3d(3, 3, 3);
    glVertex3d(-3, 3, 3);
  glEnd();

  glPopMatrix();

  /* Petit dessin avec les coordonnes pour viter un avertissement  la compilation */
  glBegin(GL_LINE);
    glVertex3i(x, y, 1);
    glVertex3i(x + larg, y + haut, 0);
  glEnd();
#else
  TRC_RectanglePlein( fenetre, x, y, larg, haut );
#endif
}

boolean clavier(Fenetre *fenetre, unsigned int touche, int etat)
{
  char txt[64];

  if ( etat & K_CTRL ) {
    (void) printf("Touche Ctrl appuye\n");
    return BI_EVENEMENT_TRAITE;
  }

  if ( touche == '+' ) {
    Zdist += 1.0;
  } else if ( touche == '-' ) {
    Zdist -= 1.0;
  } else {
    return BI_EVENEMENT_FIN_PRG;
  }

  FEN_redessin(fenetre, BI_RDS_TOUT);

  snprintf( txt, sizeof(txt), "Z Dist: %f", Zdist );
  FEN_infos( fenetre, txt );

  return BI_EVENEMENT_TRAITE;
}

int main(void) {
  Fenetre *fenetre;
  boolean sortie = FAUX;

  /* Pour charger un ressource :
     initialise("nom_ressource", nbr_arbres_ds_ressource, nbr_arbres_total);
  */

  BI_synchronisation = VRAI;	/* Pour avoir le problme ds qu'il arrive */
  if ( BI_Initialiser( NULL, 0, NULL, NULL ) == FAUX ) {
    return -1;
  }

  fenetre = FEN_CreerFenetreGL( NAME|MOVER|FULLER|SIZER|INFO, "Fentre d'essai",
				redessin,
				( void (*)(Fenetre *, int, int, int) ) NULL, 
				clavier,
				( int (*)(Fenetre *, int, int, int , int, int) ) NULL,
				( int (*)(Fenetre *, Message *) ) NULL,
				( void (*)(Fenetre *, int, int, int, int) ) NULL,
				( int (*)(Fenetre *) ) NULL );
/*   fenetre->drapeaux.pointeur = VRAI; */
  FEN_Ouvrir(fenetre, 10, 10, 200, 200);

  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0, 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL);
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

  BI_Terminer();
  return 0;
}
