/* Bibliothque X-Window pour les interfaces
            Routines d'accs systme : rcriture du TOS
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 13 avril 1998
   * Cration du fichier
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "Bib_X.h"

/* ######## Fonctions GEMDOS ######## */

/* ~~~~~~~~ Fonctions de disque ~~~~~~~~~~ */

static DTA *DTA_programme = NULL;

DTA *Fgetdta(void)
{
  return DTA_programme;
}

int Fsetdta(DTA *dta)
{
  DTA_programme = dta;
  return 0; /* Tout s'est bien pass */
}

int Fsfirst(char *masque, int attributs)
{
  printf(" FAIRE : Fsfirst(%s, %d)\n", masque, attributs);
  return 0; /* Tant que je ne sais pas comment faire sous unix... */
}

int Fsnext (void)
{
  return 0;
}

/* ~~~~~~~~ Fonctions temporelles ~~~~~~~~ */

#ifdef _ENGLISH_

const char *_Mois_[12] =
{
  "January", "February", "March"    , "April"  , "May"     , "June",
  "July"   , "August"  , "September", "October", "November", "December"
};

#else

const char *_Mois_[12] =
{
  "janvier", "f"e_AIGU"vrier", "mars"     , "avril"  , "mai"     , "juin",
  "juillet", "ao"u_CIRC"t"   , "septembre", "octobre", "novembre", "d"e_AIGU"cembre"
};

#endif

Date_Gemdos TGetdate(void)
{
  Date_Gemdos date;
  struct tm *date_c;
  time_t temps_ecoule;

  temps_ecoule = time(NULL);
  date_c = localtime( &temps_ecoule );

  date.jour  = date_c->tm_mday;
  date.mois  = date_c->tm_mon + 1;   /* Mois compts depuis 0 = janvier */
  date.annee = date_c->tm_year - 80; /* Compte depuis 1900 ; depuis 1980 sous TOS */

  return date;
}

Heure_Gemdos TGettime(void)
{
  Heure_Gemdos heure;
  time_t temps_ecoule;
  struct tm *heure_c;

  temps_ecoule = time(NULL);
  heure_c = localtime( &temps_ecoule );

  heure.heure   = heure_c->tm_hour;
  heure.minute  = heure_c->tm_min;
  heure.seconde = heure_c->tm_sec;

  return heure;
}

#ifdef TOS_COMPLET_
/* ######## Fonctions BIOS ######## */
 
void  Getmpb  (void *pointeur);
int   Bconstat(int peripherique);
long  Bconin  (int peripherique);
void  Bconout (int peripherique, int car);
long  Rwabs   (int rwflags, void *buffer, int nbr, int depart, int lecteur);
void *Setexec (int numero, void *vecteur);
long  Tickcal (void);
void *Getbpb  (int dev);
#endif

/* ------ Peut-on sortir un caractre ?
   Sous X, renvoie de toute faon -1, sauf pour midi : 0 (car rare sous X...) */

long  Bcostat (int peripherique)
{
  long retour = -1L;

  switch (peripherique)
  {
  case bios_IMPRIMANTE: /* Voir sur /dev/lpt1 ? */
    break;

  case bios_RS_232: /* Voir sur /dev/com1 ? */
    break;

  case bios_CONSOLE: /* Voir sur /dev/console ? */
    break;

  case bios_MIDI:
  case bios_IKBD:
  case bios_ECRAN:
    retour = 0L;

  default:
    (void) fprintf(stderr, "Priphrique inconnu : %d\n", peripherique);
    retour = 0L;
  }

  return retour;
}

#ifdef TOS_COMPLET_
long  Mediach (int peripherique);
long  Drvmap  (void);
long  Kbshift (int mode);
#endif

/* ######## Fonctions XBIOS ######## */

int Getrez(void)
{
  return 2; /* Toujours en haute rsolution par hypothse */
}
