/* Bibliothque X-Window pour les interfaces
            Dclaration des variables globales (fichier  inclure)
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 25 mars 1998
   * Cration du fichier
*/

#ifndef X_VDI_H_

#define X_VDI_H_ /* Protection contre l'inclusion multiple */

/* ~~~~~~~~~~ La dfinition de la station de travail ~~~~~~~ */

typedef struct vx_Xpalette {
  struct vx_Xpalette *ancienne;
  XColor couleurs[256];
} VDI_XPalette; /* USAGE INTERNE UNIQUEMENT */

typedef struct station
{
  int type;
  int handle;     /* Identifiant unique */
  int larg;       /* largeur de la station de travail    */
  int haut;       /* hauteur de la station de travail    */
  int n_plans;    /* nombre de plans d'images            */
  float x_pixel;  /* largeur d'un pixel en mm            */
  float y_pixel;  /* hauteur d'un pixel en mm            */
  int max_pts;    /* Nombre maximal de points dans ptsin */
  int nbr_fontes; /* Nombre de fontes disponibles        */

  /* Spcifique  X-Window */
  struct station *suivante; /* Pour le chanage des stations... */
  GC gr_contexte; /* Les infos de dessin de cette station */

  XFontStruct *fonte;   /* Fonte de la station */
  XColor couleurs[256]; /* Les couleurs de la station */
  VDI_XPalette *ancienne; /* NULL, utilisee pour changer temporairement une palette */

  int lgn_couleur; /* Couleur des lignes */
  int lgn_style;   /* Style de ligne     */
  int lgn_epaisseur; /* paisseur de ligne */
  int lgn_debut;   /* Dbut de ligne */
  int lgn_fin;     /* Fin de ligne   */

  int txt_couleur; /* Couleur du texte                   */
  int txt_just;    /* Justification horizontale du texte */
  int txt_vert;    /* Justification verticale du texte   */
  int txt_haut;    /* Taille du texte                    */
  int txt_angle;   /* Angle de rotation du texte         */

  int fil_couleur; /* Couleur de remplissage             */

  int mk_couleur;  /* Couleur du marqueur                */
  int mk_taille;   /* Dimensions du marqueur (en pixels) */
  int mk_type;     /* Type de marqueur                   */
} Station_VDI;

Station_VDI *VDI_ouvre     (int type);
Station_VDI *quelle_station(int handle);

int VDI_ferme(Station_VDI *station);

/* ~~~~~~~~~~ Gestion des couleurs ~~~~~~~~ */

typedef Colormap Palette; /* Hack interne pour avoir un choix dpendant de la palette */

Palette VDI_creer_palette   (void);
int     VDI_creer_degrade   (Station_VDI *station, int couleur, Palette palette);
int     VDI_sauver_palette  (Station_VDI *station);
int     VDI_rappelle_palette(Station_VDI *station);

/* ~~~~~~ Modes d'criture [pour vswr_mode(handle,_mode_)] ~~~~~~~~~~~~~~~~~~~ */

#define MD_REMPLACE    BI_MODE_REMPLACE
#define MD_TRANSPARENT BI_MODE_TRANSPARENT
#define MD_INVERSE     BI_MODE_INVERSE
#define MD_EFFACE      BI_MODE_EFFACE

#define ALL_WHITE        0 /* bit blt rules */
#define S_AND_D          1
#define S_AND_NOTD       2
#define S_ONLY           3
#define NOTS_AND_D       4
#define D_ONLY           5
#define S_XOR_D          6
#define S_OR_D           7
#define NOT_SORD         8
#define NOT_SXORD        9
#define D_INVERT        10
#define S_OR_NOTD       11
#define NOT_D           12
#define NOTS_OR_D       13
#define NOT_SANDD       14
#define ALL_BLACK       15

/* ~~~~~~~~ Styles de ligne ~~~~~~~~~~~~~~ */

#define SOLID      BI_CONTINU
#define LDASHED    BI_TIRET_LONG
#define DOTTED     BI_POINTS
#define DASHDOT    BI_TIRET_POINT
#define DASH       BI_TIRET_COURT
#define DASHDOTDOT BI_TIRET_2POINTS

/* ~~~~~~~~ Motifs de remplissage ~~~~~~~~ */

#define FIS_HOLLOW       0 /* gsx styles */
#define FIS_SOLID        1
#define FIS_PATTERN      2
#define FIS_HATCH        3
#define FIS_USER         4

/* ~~~~~~ Types de marques [pour v_polymark et autres de cette famille] ~~~~~~ */

#define PM_POINT       BI_MARQUE_POINT
#define PM_PLUS        BI_MARQUE_PLUS
#define PM_ASTERISQUE  BI_MARQUE_ASTERISQUE
#define PM_CARRE       BI_MARQUE_CARRE
#define PM_CROIX       BI_MARQUE_CROIX
#define PM_LOSANGE     BI_MARQUE_LOSANGE

/* ~~~~~~~~ Textes ~~~~~~~~~~~~~~~~~~~~ */

/* #define ALI_LEFT         0 /\* horizontal text alignment *\/ */
/* #define ALI_CENTER       1 */
/* #define ALI_RIGHT        2 */

/* #define ALI_BASE         0 /\* vertical text alignment *\/ */
/* #define ALI_HALF         1 */
/* #define ALI_ASCENT       2 */
/* #define ALI_BOTTOM       3 */
/* #define ALI_DESCENT      4 */
/* #define ALI_TOP          5 */

/* ~~~~~~~~~~~~~~ GDOS ~~~~~~~~~~~~~~~~ */

#define DEV_MISSING   0 /* Pilote absent     */
#define DEV_INSTALLED 1 /* Pilote disponible */

#endif /* X_VDI_H_ */
