/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (c) 1996 - 2004 Emmanuel CURIS
   Cration : le 8 janvier 2004

   Rcupration des donnes exprimentales pour obtenir  total

   Corrections de temps mort pour un dtecteur
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "systeme.h"

#include "import_xas.h"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

/* ~~~~~~~~ Ralisation pratique ~~~~~ */

double EXTRAIT_CorrigeTempsMort(double Imesuree, double constante, double tps_mesure, double tps_mort)
{
  double facteur;

  if ( 0.0 >= tps_mesure ) {
    (void) fprintf(stderr, "%s,%s l.%u : Valeur de temps de mesure absurde [%g]\n",
		   __FILE__, __FUNCTION__, __LINE__, tps_mesure);
    return 0.0;
  }

  /* Le temps mort en units utilisables */
  tps_mort *= constante;

  /* Facteur correctif */
  facteur = 1.0 - tps_mort/tps_mesure;
  if ( facteur <= 0.0 ) {
    (void) fprintf(stderr, "%s,%s l.%u : Temps mort trop important ! [%g%%]\n",
		   __FILE__, __FUNCTION__, __LINE__, (tps_mort/tps_mesure) * 100.0);
    return -1.0; /* Analogue  une saturation ! */
  }

  /* Ivraie   = nbr_coups / tps_actif = nbr_coups / (tps_mesure - tps_mort)
     Imesure = nbr_coups / tps_mesure
     ==> Ivraie = Imesure / (1 - tps_mort/tps_mesure) */
/*   printf( " f = %g = 1 - %g/%g ", facteur, tps_mort, tps_mesure ); */
  return Imesuree/facteur;
}
