/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (c) 1998, Emmanuel CURIS
   Cration : 14 mai 1998 / Sun : gcc
   Dernire modification : 17 novembre 1998

   Messages d'erreur pour le module d'interfaage FEFF / xanes
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "systeme.h"

/* Les textes des messages d'alerte */

static const char *FEF_alertes[] =
{
  "[3][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "|   Aucun atome n'a "e_AIGU"t"e_AIGU" d"e_AIGU"fini !"
     "| Il  est  donc  impossible d'en"
     "| utiliser pour FEFF...][Abandon]",

  "[3][-- Coh"e_AIGU"rence du mod"e_GRAVE"le FEFF --| "
     "|       Le mod"e_GRAVE"le que vous avez"
     "|d"e_AIGU"fini ne contient aucun atome"
     "|absorbeur !][Abandon]",

  "[1][-- Param"e_AIGU"trage de FEFF 6 --| "
     "|     Un atome absorbeur est"
     "|d"e_AIGU"j"a_GRAVE" d"e_AIGU"fini. Voulez-vous le"
     "|remplacer ?][Remplacer|Abandon]",

  "[1][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "|          Il n'y a pas assez de"
     "| potentiels   disponibles  pour"
     "| d"e_AIGU"crire tous les "e_AIGU"l"e_AIGU"ments !][Continuer|Abandon]",

  "[1][---- Param"e_AIGU"trage de FEFF 6 ----| " /* POTENTIEL_FAUX */
     "|  Le potentiel %d ne peut"
     "|pas "e_CIRC"tre g"e_AIGU"r"e_AIGU" par FEFF ! Seuls"
     "|les potentiels 0 "a_GRAVE" 7 existent.][Abandon]",

  "[2][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "|   Utiliser tous les atomes en "
     "|m"e_AIGU"moire  pour FEFF.  Que faire "
     "|des atomes existants ?][Garder|Effacer|Abandon]",

  "[2][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "|  Voulez-vous vraiment effacer "
     "|cet atome du mod"e_GRAVE"le FEFF ?][Effacer|Abandon]",

  "[3][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "|   Cet atome a d"e_AIGU"j"a_GRAVE" "e_AIGU"t"e_AIGU" int"e_AIGU"gr"e_AIGU
     "|au mod"e_GRAVE"le FEFF.][Abandon]",

  "[2][---- Param"e_AIGU"trage de FEFF 6 ----| "
     "| Voulez-vous r"e_AIGU"ellement effacer"
     "|tous  les atomes du mod"e_GRAVE"le FEFF"
     "|actuellement d"e_AIGU"finis ?][Effacer|Abandon]",

  "[1][---- Param"e_AIGU"trages de FEFF ----| "
     "|       Une couche de r"e_AIGU"flexion "
     "|   simple ne peut pas avoir un "
     "|   index n"e_AIGU"gatif.][Abandon]",

  "[1][---- Param"e_AIGU"trages de FEFF ----| "
     "|Voulez-vous r"e_AIGU"ellement effacer "
     "|     cette couche de r"e_AIGU"flexion "
     "|                      simple ?][Effacer|Abandon]",

  "[1][---- Param"e_AIGU"trages de FEFF ----| " /* FSS_EXISTE_DEJA */
     "|       Une couche de r"e_AIGU"flexion "
     "|  simple ayant l'index %d      "
     "|  existe d"e_AIGU"j"a_GRAVE" !][Abandon]",

  "[1][---- Param"e_AIGU"trages de FEFF ----| "
     "| La d"e_AIGU"g"e_AIGU"n"e_AIGU"rescence de la "
     "| couche ne peut pas "e_CIRC"tre       "
     "| n"e_AIGU"gative !][Abandon]",

  "[1][---- Param"e_AIGU"trages de FEFF ----| "
     "|      Une distance ne peut pas"
     "|"e_CIRC"tre n"e_AIGU"gative ou nulle !][Abandon]",

  "[2][---- Chargement de FEFF.INP ---| "
     "|     Doit-on effacer les atomes"
     "|d"e_AIGU"j"a_GRAVE" en m"e_AIGU"moire, ou ajouter les"
     "|atomes de ce fichier FEFF.INP ?][Effacer|Ajouter]",

  "[1][-- Coh"e_AIGU"rence du mod"e_GRAVE"le FEFF --| "
     "|  Le mod"e_GRAVE"le propos"e_AIGU" ne contient"
     "|aucun atome.][Arr"e_CIRC"ter|Continuer]",

  "[2][-- Coh"e_AIGU"rence du mod"e_GRAVE"le FEFF --| " /* POT_SS_ATOME */
     "|  Le potentiel %d est d"e_AIGU"fini,"
     "|mais n'est jamais utilis"e_AIGU".][Corriger|Arr"e_CIRC"ter]",

  "[1][FEFF : incoh"e_AIGU"rence des donn"e_AIGU"es"
     "|  L'organisation en m"e_AIGU"moire des"
     "| donn"e_AIGU"es du mod"e_GRAVE"le FEFF a "e_AIGU"t"e_AIGU" "
     "| perturb"e_AIGU"e. Conseil : tout sauver"
     "| et quitter le programme.][ Compris ]",

  "[1][-- Coh"e_AIGU"rence du mod"e_GRAVE"le FEFF --| " /* POT_NON_DEFINI */
     "|  Le potentiel %d est utilis"e_AIGU
     "|dans le mod"e_GRAVE"le, mais n'a pas "
     "|"e_AIGU"t"e_AIGU" d"e_AIGU"fini.][Arr"e_CIRC"ter]",

  "[3][-- Chargement d'un FEFF.INP --"
     "|Le fichier contient la commande"
     "|IORDER ; cette commande n'est"
     "|pas reconnue par le programme :"
     "|vous devrez la rajouter apr"e_GRAVE"s.][Continuer]",

  "[3][-- Chargement d'un FEFF.INP --| " /* COMMANDE_INCONNUE */
     "|  Le fichier contient une"
     "|commande inconnue :"
     "|  %s][Arr"e_CIRC"ter|Continuer]",

  "[3][-- Incoh"e_AIGU"rence du mod"e_GRAVE"le --"
     "|   Le num"e_AIGU"ro atomique de"
     "|l'absorbeur (%d) n'est pas"
     "|celui du potentiel 0 (%d)][Annuler]",

/*     v----------------------------v */
  "[2][-- Incoh"e_AIGU"rence du mod"e_GRAVE"le --"
     "|   Aucune coordonn"e_AIGU"e atomique"
     "| pour l'atome absorbeur.][ Suite ]",

/*     v----------------------------v */
  "[2][-- Commande END rencontr"e_AIGU"e |"
     "| Normalement, ce qui suit est"
     "|ignor"e_AIGU" - qu'en faire ?][Ignorer|Suite]",

/*     v----------------------------v */
  "[3][----- Calculs avec FEFF -----"
     "|Le calcul FEFF lanc"e_AIGU" est fini"
     "|(%.28s)][ Suite ]",

/*     v----------------------------v */
  "[3][----- Calculs avec FEFF -----"
     "| FEFF a t interrompu - code"
     "|de sortie : %d][ Suite ]"

/*     v----------------------------v */
  "[3][----- Calculs avec FEFF -----"
     "| FEFF a t interrompu - code"
     "|de sortie : %d][ Suite ]",

/*     v----------------------------v */
  "[3][----- Calculs avec FEFF -----"
     "| Impossible de lancer FEFF !"
     "| Raison : %.20s][ Suite ]"
};

#define NBR_ALERTES_FEFF 26

extern char vrai_message[]; /* Dans ../variables.c */

int FEFF_ERREUR(unsigned int code_erreur, ...)
{
  int retour;
  int i_1, i_2;
  va_list lst_params;

  if (code_erreur >= NBR_ALERTES_FEFF) /* Message inconnu */
    return SYS_ERREUR(ERREUR_INCONNUE, code_erreur, "Interface FEFF");

  va_start(lst_params, code_erreur);

  switch (code_erreur)
  {
  case POTENTIEL_FAUX: /* Messages d'erreur  un paramtre, de type int */
  case FSS_EXISTE_DEJA:
  case POT_SS_ATOME:
  case POT_NON_DEFINI:
  case FEFF_INTERROMPU:
    i_1 = va_arg(lst_params, int);
    sprintf(vrai_message, FEF_alertes[code_erreur], i_1 );
    retour = form_alert(1, (const char *) vrai_message);
    break;

  case COMMANDE_INCONNUE: /* Un paramtre de type char * */
  case FEFF_TERMINE:
  case FEFF_NON_LANCE:
    sprintf(vrai_message, FEF_alertes[code_erreur], va_arg(lst_params, char *) );
    retour = form_alert(1, (const char *) vrai_message);
    break;

  case Z_ABSORBEUR_DIFFERENTS: /* Messages d'erreur  deux paramtres : deux entiers */
    i_1 = va_arg(lst_params, int);
    i_2 = va_arg(lst_params, int);
    sprintf(vrai_message, FEF_alertes[code_erreur], i_1, i_2);
    retour = form_alert(1, (const char *) vrai_message); 
    break;

  default:
    retour = form_alert(1, FEF_alertes[code_erreur] );
  }

  va_end(lst_params);
  return retour;
}
