/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1998-2006, Emmanuel CURIS
   Cration : mars 2006

   Interface graphique avec l'utilisateur

   Intgration (graphe : rel, complexe)
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "systeme.h"

#include "serie.h"
#include "interface.h"
#include "operations.h"

/* -------- Variables locales -------- */

static const BI_Boite_Alerte Q_MethodeDerivee = {
  ERR_ICONE_QUESTION,
  "Calcul d'une d"e_AIGU"riv"e_AIGU"e",
  "Quelle m"e_AIGU"thode voulez-vous utiliser pour calculer la d"e_AIGU"riv"e_AIGU"e du graphe choisi ?",
  3, 1, 3,
  { "Simple", "Splines", "Annuler", NULL, NULL }
};

/* -------- Fonctions locales -------- */

/* ~-~-~-~-~-~-~-~-~ Drivation d'un graphe [valeurs relles ou complexes] ~-~-~-~-~-~-~-~-~ */

Graphe *I_GRF_Derivee(Graphe *graphe)
{
  Graphe *derivee = NULL;
  int reponse, methode = DER_RAPIDE;

  if ( NULL == graphe ) return NULL;

  /* Pour l'instant, trs simple : donne le choix entre deux mthodes ! */
  reponse = BI_ERR_alerte( principale, &Q_MethodeDerivee, VRAI );
  if ( 3 == reponse ) return NULL;
  if ( 2 == reponse ) methode = DER_SPLINE;
  if ( 1 == reponse ) methode = DER_RAPIDE;

  /* On fait le calcul proprement dit */
  derivee = GRF_Deriver( graphe, methode );

  /* A-t-on russi  faire quelque chose ? */
  if ( derivee != NULL ) {
    /* On l'insre dans la srie du graphe original, sauf si impossible ! */
    I_GRF_InsererDansSerie( NULL, graphe, derivee );

    /* On fait le post-traitement : couleurs, units,... */
    GRF_Derivee_PostCalcul( graphe, derivee, 0 );
  }

  return derivee;
}
