/* Fonctions utilitaires gnrales
   Dveloppes pour LASE, mais plus gnriques
   (C) 1996 - 2002, Emmanuel CURIS

   Lecture, criture "avances" des fichiers en binaire : dclarations
*/

#ifndef BINAIRES_UTILS_H_

#define BINAIRES_UTILS_H_ /* Protection contre l'inclusion multiple */

#ifndef FAUX
# define FAUX 0
# define VRAI 1
#endif

struct orientation_3d; /* Dans utils_3d.h */
struct vect_3d;

/* ~-~-~-~-~-~-~-~-~ Lecture ~-~-~-~-~-~-~-~-~ */

inline char *BIN_CH_chaine(FILE *fichier);
inline int BIN_CH_orientation(FILE *fichier, struct orientation_3d *orientation);
inline int BIN_CH_vecteur_3d (FILE *fichier, struct vect_3d *vecteur);

#define BIN_MODE_SOURCE_MSB    0 /* fichier : au format rseau = 21, 4321 */
#define BIN_MODE_SOURCE_LSB    1 /* fichier : au format Intel  = 12, 1234 */
#define BIN_MODE_SOURCE_IMIXTE 2 /* fichier : au format rseau mixte = 21, 2143 */
#define BIN_MODE_SOURCE_MMIXTE 3 /* fichier : au format Intel mixte  = 12, 3412 */

inline short BIN_Lire_8 (FILE *fichier);
inline int   BIN_Lire_16(FILE *fichier, int mode);
inline long  BIN_Lire_32(FILE *fichier, int mode);
inline unsigned short BIN_Lire_8U (FILE *fichier);
inline unsigned int   BIN_Lire_16U(FILE *fichier, int mode);
inline unsigned long  BIN_Lire_32U(FILE *fichier, int mode);

inline float BIN_LireFlottant(FILE *fichier, int mode);

/* ~-~-~-~-~-~-~-~-~ criture ~-~-~-~-~-~-~-~-~ */

inline int BIN_SV_chaine     (FILE *fichier, const char *chaine);
inline int BIN_SV_orientation(FILE *fichier, struct orientation_3d *orientation);
inline int BIN_SV_vecteur_3d (FILE *fichier, struct vect_3d *vecteur);

/* ~-~-~-~-~-~-~-~-~ Divers ~-~-~-~-~-~-~-~-~ */

inline int BIN_InclureFichier(FILE *fichier, const char *nom_fichier);

/* ~-~-~-~-~-~-~-~-~ Dossiers ~-~-~-~-~-~-~-~-~ */

char **DIR_ListeFichiers(const char *dossier, const char *masque, unsigned long *nombre_fichiers);

#endif /* BINAIRES_UTILS_H_ */
