/* LASE - Logicie d'Analyse des Spectres Exprimentaux
   Logs divers pour faciliter le dboguage
   (c) 2002 - Emmanuel CURIS
*/

#ifndef DEBOGUE_H_
# define DEBOGUE_H_ /* Pas d'inclusion multiple */

/* Dcommenter pour activer un type de log */

/*#define DEBOGUE_MALLOC_ 1*/ /* Commenter pour ne pas avoir de log de la mmoire */

#define FAUX 0
#define VRAI 1

int DEBOGUE_init_logs(void);
void DEBOGUE_arrete_logs(void);

#if defined(DEBOGUE_MALLOC_)
# if defined(AVEC_DB_MALLOC_)
#  include <dbmalloc.h>
#  undef DEBOGUE_MALLOC_ /* Plus ncessaire ! */
# else
void Malloc_Logue(char *masque, ...);

void *debogue_malloc (size_t taille);
void *debogue_calloc (size_t nombre, size_t taille);
void *debogue_realloc(void *pointeur, size_t taille);
void  debogue_free   (void *pointeur);
char *debogue_strdup (const char *chaine);

#  define malloc(truc)         debogue_malloc( truc )
#  define calloc(truc,chose)   debogue_calloc( truc, chose )
#  define realloc(truc,chose)  debogue_realloc( truc, chose )
#  ifndef strdup /* strdup peut etre dfinie comme une macro : gcc optimis. Alors, on ne la redfinit pas... */
#   define strdup(truc)         debogue_strdup( truc )
#  endif
#  define free(truc)           debogue_free( truc )
# endif
#endif

/* #define DEBOGUE_FONCTIONS_ 1 */

#ifdef DEBOGUE_FONCTIONS_
void ENTREE_FONCTION(const char *nom_fonction, const char *params, ...);
void DANS_FONCTION  (const char *texte, ...);
void SORTIE_FONCTION(const char *nom_fonction, const char *renvoi, ...);
#else
# define ENTREE_FONCTION(nom, params, ...) /* Inutile */
# define DANS_FONCTION(nom, ...)            /* Inutile */
# define SORTIE_FONCTION(nom, renvoi, ...) /* Inutile */
#endif

#endif /* DEBOGUE_H_ */
