// Inclusions pour la chimie avec POV
// (C) 1999, Emmanuel CURIS
// Le but de ce fichier est de dfinir un style par lment, pour utilisation avec LASE

// Mtaux : on essaye d'utiliser les dfinitions POV quand elles existent
// Les couleurs sont choisies en fonction des conventions usuelles en chimie
//   gaz = les sphres sont faites en verre
//   liquide = les sphres sont
//   solide  = les sphres sont pleines

#include "metals.inc"
#include "woods.inc"

#declare non_fait = color Aquamarine ;

#declare Hydrogene = texture { pigment { color White } finish { F_Glass4 } }
#declare Helium = pigment { color White } // Normalement, ne devrait jamais tre utilis

#declare Lithium = non_fait;
#declare Beryllium = non_fait;
#declare Bore = non_fait;
#declare Carbone = pigment { color Gray75 }
#declare Azote = pigment { color Blue }
#declare Oxygene = pigment { color Red }
#declare Fluor = texture { pigment { color DarkGreen } finish { F_Glass1 } }
#declare Neon = pigment { color White }

#declare Sodium = non_fait;
#declare Magnesium = non_fait;
#declare Aluminium = non_fait;
#declare Silicium = non_fait;
#declare Phosphore = texture { pigment { color SlateBlue } finish {reflection .5} }
#declare Soufre = pigment { color Yellow }
#declare Chlore = texture { pigment { color Green } finish { F_Glass3 } }
#declare Argon = pigment { color White }

#declare Calcium = texture { T_Wood10 rotate <2.0, 0, 0> }

#declare Zinc = texture { pigment { color Gray25 } finish { F_MetalD } }

#declare Platine = texture { T_Silver_2E }

// Fin des dclarations